#include <iostream>

class Base {
public:
    virtual void print() const {
        std::cout << "Base class" << std::endl;
    }
};

class Derived : public Base {
public:
    void print() const override {
        std::cout << "Derived class" << std::endl;
    }
};

int main() {
    Derived d;
    Base* bp = &d;

    bp->print();  // Calls Derived::print()

    // Explicitly call Base::print using void cast
    (bp->*static_cast<void (Base::*)() const>(&Base::print))();

    return 0;
}
