#include <iostream>
#include <type_traits>

template<typename T>
struct Helper {
    static void print() {
        std::cout << "Non-void type" << std::endl;
    }
};

template<>
struct Helper<void> {
    static void print() {
        std::cout << "Void type" << std::endl;
    }
};

template<typename T>
void process() {
    Helper<T>::print();
}

// Overload for void
void process() {
    Helper<void>::print();
}

int main() {
    process<int>();
    process<void>();
    process();  // Calls the non-template overload

    return 0;
}
