#include <iostream>
#include <type_traits>

template<typename T>
struct Helper {
    static void print() {
        std::cout << "Non-void type" << std::endl;
    }
};

template<>
struct Helper<void> {
    static void print() {
        std::cout << "Void type" << std::endl;
    }
};

template<typename T = void>
void process() {
    Helper<T>::print();
}

int main() {
    process<int>();
    process<void>();
    process<>();  // Defaults to void in C++14 and later

    return 0;
}
